%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% FI:PA171 - Digital Filters
%
% topic: IIR filters, Z-transform, Steerable filters
% author: David Svoboda 
%         Masaryk University (c) 2019
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --------------------------------------------------------------------
% 1. Proof the equivalence of FIR and IIR averaging filter from the lecture
% --------------------------------------------------------------------

% no code here - use white-board/sheet of paper ;-)

% --------------------------------------------------------------------
% 2. Compare the recursive Gaussian implemented using Jin's approach
% with the standard Gaussian
%
% 'sigma' is a free parameter
% --------------------------------------------------------------------

clear all;
sigma=1.2 % change sigma here

alfa = exp(-1/(2*sigma^2))
k = 1/(sigma*sqrt(2*pi))
p = (alfa/2)*(3-alfa^2 - sqrt(9-6*alfa^2-3*alfa^4))
b1 = -3*p
b2 = 3*p^2
b3 = -p^3
a1 = alfa - 3*p
a2 = alfa^4 - 3*alfa*p + 3*p^2
a3 = a1 - b1
a4 = a2 - b2
a5 =  -b3

length = 100

f = zeros(1,2*length+1)
f(length+1)=1
h_plus = zeros(1,2*length+1);
h_minus = zeros(1,2*length+1);

% left to right
for n=4:2*length+1
    h_plus(n) = k*(f(n) + a1*f(n-1) + a2*f(n-2)) - (b1*h_plus(n-1) + b2*h_plus(n-2) + b3*h_plus(n-3));
end 

% right to left
for n=2*length+1-3:-1:1
    h_minus(n) = k*(a3*f(n+1) + a4*f(n+2) + a5*f(n+3)) - (b1*h_minus(n+1) + b2*h_minus(n+2) + b3*h_minus(n+3));
end

for n=1:2*length+1
    h(n) = h_plus(n) + h_minus(n);
end

%x=1:2*length+1;
x=[-length:length];
plot(x, k*exp(-((x).^2)/(2*sigma^2)),'b-','LineWidth',2);
hold on;
plot(x,h,'r-','LineWidth',2);
legend('standard Gaussian','recursive Gaussian');

% --------------------------------------------------------------------
% 3. Check the steerability of the 1st derivative of Gaussian
% --------------------------------------------------------------------

I = gaussf(rr < 1,20);
G_x = dx(I);
G_y = dy(I);

stretch(G_x)
stretch(G_y)

angleD = 80; % change angle here

angle = angleD*pi/180;
result = stretch(G_x*cos(angle) + G_y*sin(angle))
